from AccessControl import ClassSecurityInfo
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
import Globals

from Products.Groups.ZGroupsService import ZGroupsService
from Products.Groups.helpers import add_and_edit

class LDAPGroupsService(ZGroupsService):
    meta_type = 'Silva ETH LDAP Groups Service'

    security = ClassSecurityInfo()

    manage_options = (
        {'label':'Edit',       'action':'manage_main'},
        )
    
    manage_main = PageTemplateFile('www/groupsServiceEdit', globals())
    
    def _getNormalGroups(self, user):
        # get normal groups defined locally
        result = {}
        result.update(ZGroupsService.inheritedAttribute('_getNormalGroups')(
            self, user))
        # add groups defined by ldap
        ou = user.getProperty('ou')
        # in case we're not an ldap user
        if ou is None:
            return result
        for group in ou:
            result[group] = 1
        return result

    security.declareProtected('View management screens',
                              'loadLDAPGroups')
    def syncLDAPGroups(self):
        """Sync with LDAP groups.
        """
        for entry in self.acl_users.getGroups():
            self.addNormalGroup(unicode(entry[0], 'latin-1'))
        return self.manage_main(manage_tabs_message='Loaded groups from LDAP')
        
Globals.InitializeClass(LDAPGroupsService)

manage_addGroupsServiceForm = PageTemplateFile(
    "www/groupsServiceAdd", globals(),
    __name__='manage_addGroupsServiceForm')

def manage_addGroupsService(self, id=None, title='', REQUEST=None):
    """Add groups service."""
    if id is None:
        id = 'service_groups'
    object = LDAPGroupsService(id, title)
    self._setObject(id, object)
    add_and_edit(self, id, REQUEST)
    return ''
